
#include <mygba.h>
#include "Coleco.h"
#include "vba.h"

#define MARK ham_VBAText("reached %d in %s\n",__LINE__,__FUNCTION__)

int InitMachine(void)
{
	ham_Init();
	ham_SetBgMode(4);
	
}

void TrashMachine(void)
{
}

#define WIDTH 256
#define HEIGHT 192
byte XBuf[WIDTH*HEIGHT] MEM_IN_EWRAM;
byte XPal[16] MEM_IN_EWRAM;
byte XPal0 MEM_IN_EWRAM;
#define RefreshScreen bogus
#define PutImage(x) (0)
#include "Common.h"
#undef RefreshScreen

void MEM_FUNC_IN_IWRAM RefreshScreen(void)
{
	int i,j;
	u16* fb;
	u16* xb;
	MARK;
	fb=(u16*)(0x6000000+(ham_GetBGBuffer()?0:0xa000));
	xb=((u16*)(XBuf))+(WIDTH-240)/2/2+(HEIGHT-160)/2/2*WIDTH;
	//ham_VBAText("fb %x xb %x\n",fb,xb);
	for(j=160; j; j--)
	{
		TOOL_DMA3_SET(xb,fb,240/2,0,DMA_STARTAT_NOW);	
		fb+=240/2;
		xb+=240/2+16/2;
	}
	ham_FlipBGBuffer();
}

void Joysticks(void)
{
	JoyState[1]=0xffff;
	JoyState[0]=F_CTRLINPUT_SELECT_PRESSED +
			(F_CTRLINPUT_START_PRESSED<<1)+
			(F_CTRLINPUT_L_PRESSED<<2)+
			(F_CTRLINPUT_R_PRESSED<<3)+
			(F_CTRLINPUT_A_PRESSED<<6)+
			(F_CTRLINPUT_UP_PRESSED<<8)+
			(F_CTRLINPUT_RIGHT_PRESSED<<9)+
			(F_CTRLINPUT_DOWN_PRESSED<<10)+
			(F_CTRLINPUT_LEFT_PRESSED<<11)+
			(F_CTRLINPUT_B_PRESSED<<14);
	JoyState[0]=~JoyState[0];
}

static int palcnt=1;
void SetColor(byte N, byte R, byte B, byte G)
{
	ham_VBAText("setcolor no %d to %d/%d/%d\n",N,R,G,B);
	ham_SetBgPalColRGB(palcnt,R,G,B);	
	XPal[N]=palcnt++;
}

extern byte Verbose;

int main(void)
{
	UPeriod=4;
	monstartup(0x8000000,0x80fffff);
	InitMachine();
	Verbose=5;
	StartColeco("CART.ROM");
	TrashColeco();
	TrashMachine();
	return 0;
}

extern byte coleco_rom[];
extern byte cart_rom[];

static byte* rom=coleco_rom;
static byte* cart=cart_rom;

void* fopen(const char *path, const char *mode)
{
	ham_VBAText("my fopen, %s requested\n",path);
	if(strcmp(path,"COLECO.ROM")==0) return coleco_rom;
	else if(strcmp(path,"CART.ROM")==0) return cart_rom;
	else return 0;
}

int fclose(byte* x)
{
	ham_VBAText("my fclose\n");
	if(x==coleco_rom) rom=coleco_rom;
	else if(x==cart_rom) cart=cart_rom;
	else return -1;
	return 0;
}

int fread(void* ptr, int size, int nmemb, void* x)
{
	ham_VBAText("my fread\n");
	if(x==cart_rom)	{ memcpy(ptr,cart,size*nmemb); cart+=size*nmemb; }
	else if(x==coleco_rom) { memcpy(ptr,rom,size*nmemb); rom+=size*nmemb; }
	else return 0;
	return nmemb;
}

int puts(const char* s)
{
	ham_VBAText(s);
}

_PTR MEM_FUNC_IN_IWRAM mymemset(_PTR s, int c, size_t size)
{
	unsigned int* d=s;
	int i;
	unsigned int x=(c<<24)+(c<<16)+(c<<8)+c;
	if(size&3) { ham_VBAText("memset size %d\n",size); while(1); }
	
	for(i=size/4;i;i--) *d++=x;
	return s;
}
